<?php
require_once (dirname(__FILE__) . '/config.php');

$t = $_GET["t"];
$r = $_GET["r"];
$text_color = $_GET["c"];

$cache = "postit_" . str_replace("/", "_", $t) . "_" . $r . "_" . $text_color . ".png";

if (file_exists(dirname(__FILE__) . "/cache/" . $cache)) {
 header("Location: ".HTTP_BASE."cache/" . $cache);
 exit();
}

$font_size = 12;
$font = dirname(__FILE__) . '/font.ttf';
$ow = 100;
$oh = 100;

$out = imagecreatetruecolor($ow, $oh);
imagesavealpha($out, true);
$trans_colour = imagecolorallocatealpha($out, 0, 0, 0, 127);
imagefill($out, 0, 0, $trans_colour);
$tc = imagecolorallocatealpha($out, hexdec(substr($text_color, 0, 2)), hexdec(substr($text_color, 2, 2)), hexdec(substr($text_color, 4, 2)), 0);

$postit = imagecreatefrompng(dirname(__FILE__) . '/postit.png');
$rotated = imagerotate($postit, $r, $trans_colour);
$f = 0.2;
$fl = 0.75 / 4;
$mw = $ow * 0.55;
$fw = imagesx($rotated) * $f;
$fh = imagesy($rotated) * $f;
imagecopyresampled($out, $rotated, ($ow - $fw) / 2, ($oh - $fh) / 2, 0, 0, $fw, $fh, imagesx($rotated), imagesy($rotated));
imagedestroy($postit);
imagedestroy($rotated);

$lines = array();
$l = 0;
$s = - 1;
for($i = 0; $i < mb_strlen($t, 'UTF-8'); $i ++) {
 $p = mb_substr($t, $l, $i - $l, 'UTF-8');
 if (mb_substr($t, $i, 1, 'UTF-8') == ' ') {
  $s = $i;
 }
 $dim = imagettfbbox($font_size, 0, $font, $p);
 if ($dim[4] > $mw) {
  if ($s != - 1) {
   $lines[] = mb_substr($t, $l, $s - $l, 'UTF-8');
   $l = $s;
  } else {
   $lines[] = mb_substr($t, $l, $i - $l, 'UTF-8');
   $l = $i;
  }
  $s = - 1;
 }
}
if ($l < mb_strlen($t, 'UTF-8')) {
 $lines[] = mb_substr($t, $l, strlen($t), 'UTF-8');
}

$c = 0;
for($i = (count($lines) > 1 ? - 1 : 0); $i < min(2, count($lines)); $i ++) {
 $x = cos($r * 3.14 / 180) * $ow / 3 - sin($r * 3.14 / 180) * $oh * $fl * $i;
 $y = sin($r * 3.14 / 180) * $oh / 3 + cos($r * 3.14 / 180) * $ow * $fl * $i;
 imagettftext($out, $font_size, $r, $ow / 2 - $x, $oh / 2 + $y, $tc, $font, trim($lines[$c ++]));
}

// output
header('Content-Type: image/png');

imageinterlace($out, 1);

imagepng($out, dirname(__FILE__) . "/cache/" . $cache);
imagedestroy($out);

header("Location: ".HTTP_BASE."cache/" . $cache);
exit();
?>
